public void HookEvents()
{
	HookEvent("round_poststart", OnRoundPostStart, EventHookMode_Post);
}

public void HookPlayer(int client)
{
	DHookEntity(g_hGiveNamedItem, false, client);
	DHookEntity(g_hGiveNamedItemPost, true, client);
	SDKHook(client, SDKHook_OnTakeDamageAlive, OnTakeDamageAlive);
}

public void UnhookPlayer(int client)
{
	SDKUnhook(client, SDKHook_OnTakeDamageAlive, OnTakeDamageAlive);
}

public bool HookOnGiveNamedItem()
{
	new Handle:config = LoadGameConfigFile("knives.games");
	if(config == INVALID_HANDLE)
	{
		LogError("Unable to load game config file: knives.games");
		return false;
	}
	
	int offset = GameConfGetOffset(config, "GiveNamedItem");
	CloseHandle(config);
	if (offset == -1)
	{
		LogError("Unable to find offset 'GiveNamedItem' in game data 'knives.games'");
		return false;
	}
	
	/* POST HOOK */
	g_hGiveNamedItemPost = DHookCreate(offset, HookType_Entity, ReturnType_CBaseEntity, ThisPointer_CBaseEntity, OnGiveNamedItemPost);
	
	if (g_hGiveNamedItemPost == INVALID_HANDLE)
	{
		LogError("Unable to post hook 'int CCSPlayer::GiveNamedItem(char const*, int, CEconItemView*, bool)'");
		return false;
	}
	
	DHookAddParam(g_hGiveNamedItemPost, HookParamType_CharPtr, -1, DHookPass_ByRef);
	DHookAddParam(g_hGiveNamedItemPost, HookParamType_Int, -1, DHookPass_ByVal);
	DHookAddParam(g_hGiveNamedItemPost, HookParamType_Int, -1, DHookPass_ByRef);
	DHookAddParam(g_hGiveNamedItemPost, HookParamType_Bool, -1, DHookPass_ByVal);
	
	/* PRE HOOK */
	g_hGiveNamedItem = DHookCreate(offset, HookType_Entity, ReturnType_CBaseEntity, ThisPointer_CBaseEntity, OnGiveNamedItem);
	
	if (g_hGiveNamedItem == INVALID_HANDLE)
	{
		LogError("Unable to hook 'int CCSPlayer::GiveNamedItem(char const*, int, CEconItemView*, bool)'");
		return false;
	}
	
	DHookAddParam(g_hGiveNamedItem, HookParamType_CharPtr, -1, DHookPass_ByRef);
	DHookAddParam(g_hGiveNamedItem, HookParamType_Int, -1, DHookPass_ByVal);
	DHookAddParam(g_hGiveNamedItem, HookParamType_Int, -1, DHookPass_ByRef);
	DHookAddParam(g_hGiveNamedItem, HookParamType_Bool, -1, DHookPass_ByVal);
	return true;
}

