stock void BuildKnivesMenu()
{
	g_hKnivesMenu = CreateMenu(OnClientMenuAction);
	SetMenuTitle(g_hKnivesMenu, "Select Knife");
	SetMenuExitBackButton(g_hKnivesMenu, false);
	SetMenuExitButton(g_hKnivesMenu, true);
	
	char info[32];
	int count = sizeof(g_iKnifeDefinitions);
	for (int i = 0; i < count; i++)
	{
		Format(info, sizeof(info), "$knives %d", g_iKnifeDefinitions[i]);
		AddMenuItem(g_hKnivesMenu, info, g_sKnifeDefinitionNames[i]);
	}
	
	AddMenuItem(g_hKnivesMenu, "$knives 0", "Default");
}

public int OnClientMenuAction(Handle menu, MenuAction action, int param1, int param2)
{
	if (action == MenuAction_Select)
	{
		char buffer[64];
		GetMenuItem(menu, param2, buffer, sizeof(buffer));
	
		if (StrContains(buffer, "$knives ") != 0)
			return;
			
		int defindex = StringToInt(buffer[7]);
		char classname[64];
		if (!GetItemDefinitionDetails(defindex, buffer, sizeof(buffer), classname, sizeof(classname)))
			return;
			
		g_iPlayerKnifeSelections[param1] = defindex;
		PrintToChat(param1, "\x01[SM] You have selected knife: \x04%s", buffer);
		
		if (IsPlayerAlive(param1))
			ReplacePlayerKnife(param1, classname);
			
		UpdatePlayerKnife(param1);
	}
}