Handle g_cvar_knives_database_name;
Handle g_cvar_knives_safemode;

public void CreateConVars()
{
	g_cvar_knives_database_name = CreateConVar("knives_database_name", "knives", "The entry in database.cfg that is used for database queries");
	HookConVarChange(g_cvar_knives_database_name, OnConVarChanged);
	GetConVarString(g_cvar_knives_database_name, cvar_knives_database_name, sizeof(cvar_knives_database_name));
	
	g_cvar_knives_safemode = CreateConVar("knives_safemode", "0", "Run plugin in safe mode");
	HookConVarChange(g_cvar_knives_safemode, OnConVarChanged);
	cvar_knives_safemode = GetConVarBool(g_cvar_knives_safemode);
}

public OnConVarChanged(Handle:cvar, const String:oldVal[], const String:newVal[])
{
	if (cvar == g_cvar_knives_database_name)
		strcopy(cvar_knives_database_name, sizeof(cvar_knives_database_name), newVal);
	if (cvar == g_cvar_knives_safemode)
		cvar_knives_safemode = StringToInt(newVal) == 1 ? true : false;
}